<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">


<html xmlns="http://www.w3.org/1999/xhtml">
  <head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    
    <title>3. Using Python on Windows &mdash; Python 3.5.1 documentation</title>
    
    <link rel="stylesheet" href="../_static/pydoctheme.css" type="text/css" />
    <link rel="stylesheet" href="../_static/pygments.css" type="text/css" />
    
    <script type="text/javascript">
      var DOCUMENTATION_OPTIONS = {
        URL_ROOT:    '../',
        VERSION:     '3.5.1',
        COLLAPSE_INDEX: false,
        FILE_SUFFIX: '.html',
        HAS_SOURCE:  true
      };
    </script>
    <script type="text/javascript" src="../_static/jquery.js"></script>
    <script type="text/javascript" src="../_static/underscore.js"></script>
    <script type="text/javascript" src="../_static/doctools.js"></script>
    <script type="text/javascript" src="../_static/sidebar.js"></script>
    <link rel="search" type="application/opensearchdescription+xml"
          title="Search within Python 3.5.1 documentation"
          href="../_static/opensearch.xml"/>
    <link rel="author" title="About these documents" href="../about.html" />
    <link rel="copyright" title="Copyright" href="../copyright.html" />
    <link rel="top" title="Python 3.5.1 documentation" href="../contents.html" />
    <link rel="up" title="Python Setup and Usage" href="index.html" />
    <link rel="next" title="4. Using Python on a Macintosh" href="mac.html" />
    <link rel="prev" title="2. Using Python on Unix platforms" href="unix.html" />
    <link rel="shortcut icon" type="image/png" href="../_static/py.png" />
    <script type="text/javascript" src="../_static/copybutton.js"></script>
    <script type="text/javascript" src="../_static/version_switch.js"></script>
    
 

  </head>
  <body role="document">  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             accesskey="I">index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="mac.html" title="4. Using Python on a Macintosh"
             accesskey="N">next</a> |</li>
        <li class="right" >
          <a href="unix.html" title="2. Using Python on Unix platforms"
             accesskey="P">previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" accesskey="U">Python Setup and Usage</a> &raquo;</li> 
      </ul>
    </div>    

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="using-python-on-windows">
<span id="using-on-windows"></span><h1>3. Using Python on Windows<a class="headerlink" href="#using-python-on-windows" title="Permalink to this headline">¶</a></h1>
<p>This document aims to give an overview of Windows-specific behaviour you should
know about when using Python on Microsoft Windows.</p>
<div class="section" id="installing-python">
<h2>3.1. Installing Python<a class="headerlink" href="#installing-python" title="Permalink to this headline">¶</a></h2>
<p>Unlike most Unix systems and services, Windows does not include a system
supported installation of Python. To make Python available, the CPython team
has compiled Windows installers (MSI packages) with every <a class="reference external" href="https://www.python.org/download/releases/">release</a> for many years. These installers
are primarily intended to add a per-user installation of Python, with the
core interpreter and library being used by a single user. The installer is also
able to install for all users of a single machine, and a separate ZIP file is
available for application-local distributions.</p>
<div class="section" id="supported-versions">
<h3>3.1.1. Supported Versions<a class="headerlink" href="#supported-versions" title="Permalink to this headline">¶</a></h3>
<p>As specified in <span class="target" id="index-0"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0011"><strong>PEP 11</strong></a>, a Python release only supports a Windows platform
while Microsoft considers the platform under extended support. This means that
Python 3.5 supports Windows Vista and newer. If you require Windows XP support
then please install Python 3.4.</p>
</div>
<div class="section" id="installation-steps">
<h3>3.1.2. Installation Steps<a class="headerlink" href="#installation-steps" title="Permalink to this headline">¶</a></h3>
<p>Four Python 3.5 installers are available for download - two each for the 32-bit
and 64-bit versions of the interpreter. The <em>web installer</em> is a small initial
download, and it will automatically download the required components as
necessary. The <em>offline installer</em> includes the components necessary for a
default installation and only requires an internet connection for optional
features. See <a class="reference internal" href="#install-layout-option"><span>Installing Without Downloading</span></a> for other ways to avoid downloading
during installation.</p>
<p>After starting the installer, one of two options may be selected:</p>
<img alt="../_images/win_installer.png" src="../_images/win_installer.png" />
<p>If you select &#8220;Install Now&#8221;:</p>
<ul class="simple">
<li>You will <em>not</em> need to be an administrator (unless a system update for the
C Runtime Library is required or you install the <a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a> for all
users)</li>
<li>Python will be installed into your user directory</li>
<li>The <a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a> will be installed according to the option at the bottom
of the first pace</li>
<li>The standard library, test suite, launcher and pip will be installed</li>
<li>If selected, the install directory will be added to your <span class="target" id="index-1"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code></li>
<li>Shortcuts will only be visible for the current user</li>
</ul>
<p>Selecting &#8220;Customize installation&#8221; will allow you to select the features to
install, the installation location and other options or post-install actions.
To install debugging symbols or binaries, you will need to use this option.</p>
<p>To perform an all-users installation, you should select &#8220;Customize
installation&#8221;. In this case:</p>
<ul class="simple">
<li>You may be required to provide administrative credentials or approval</li>
<li>Python will be installed into the Program Files directory</li>
<li>The <a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a> will be installed into the Windows directory</li>
<li>Optional features may be selected during installation</li>
<li>The standard library can be pre-compiled to bytecode</li>
<li>If selected, the install directory will be added to the system <span class="target" id="index-2"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code></li>
<li>Shortcuts are available for all users</li>
</ul>
</div>
<div class="section" id="installing-without-ui">
<span id="install-quiet-option"></span><h3>3.1.3. Installing Without UI<a class="headerlink" href="#installing-without-ui" title="Permalink to this headline">¶</a></h3>
<p>All of the options available in the installer UI can also be specified from the
command line, allowing scripted installers to replicate an installation on many
machines without user interaction.  These options may also be set without
suppressing the UI in order to change some of the defaults.</p>
<p>To completely hide the installer UI and install Python silently, pass the
<code class="docutils literal"><span class="pre">/quiet</span></code> option. To skip past the user interaction but still display
progress and errors, pass the <code class="docutils literal"><span class="pre">/passive</span></code> option. The <code class="docutils literal"><span class="pre">/uninstall</span></code>
option may be passed to immediately begin removing Python - no prompt will be
displayed.</p>
<p>All other options are passed as <code class="docutils literal"><span class="pre">name=value</span></code>, where the value is usually
<code class="docutils literal"><span class="pre">0</span></code> to disable a feature, <code class="docutils literal"><span class="pre">1</span></code> to enable a feature, or a path. The full list
of available options is shown below.</p>
<table border="1" class="docutils">
<colgroup>
<col width="30%" />
<col width="42%" />
<col width="29%" />
</colgroup>
<thead valign="bottom">
<tr class="row-odd"><th class="head">Name</th>
<th class="head">Description</th>
<th class="head">Default</th>
</tr>
</thead>
<tbody valign="top">
<tr class="row-even"><td>InstallAllUsers</td>
<td>Perform a system-wide installation.</td>
<td>0</td>
</tr>
<tr class="row-odd"><td>TargetDir</td>
<td>The installation directory</td>
<td>Selected based on
InstallAllUsers</td>
</tr>
<tr class="row-even"><td>DefaultAllUsersTargetDir</td>
<td>The default installation directory
for all-user installs</td>
<td><code class="file docutils literal"><span class="pre">%ProgramFiles%\Python</span> <span class="pre">X.Y</span></code> or <code class="file docutils literal"><span class="pre">%ProgramFiles(x86)%\Python</span> <span class="pre">X.Y</span></code></td>
</tr>
<tr class="row-odd"><td>DefaultJustForMeTargetDir</td>
<td>The default install directory for
just-for-me installs</td>
<td><code class="file docutils literal"><span class="pre">%LocalAppData%\Programs\PythonXY</span></code> or
<code class="file docutils literal"><span class="pre">%LocalAppData%\Programs\PythonXY-32</span></code></td>
</tr>
<tr class="row-even"><td>DefaultCustomTargetDir</td>
<td>The default custom install directory
displayed in the UI</td>
<td>(empty)</td>
</tr>
<tr class="row-odd"><td>AssociateFiles</td>
<td>Create file associations if the
launcher is also installed.</td>
<td>1</td>
</tr>
<tr class="row-even"><td>CompileAll</td>
<td>Compile all <code class="docutils literal"><span class="pre">.py</span></code> files to
<code class="docutils literal"><span class="pre">.pyc</span></code>.</td>
<td>0</td>
</tr>
<tr class="row-odd"><td>PrependPath</td>
<td>Add install and Scripts directories
tho <span class="target" id="index-3"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> and <code class="docutils literal"><span class="pre">.PY</span></code> to
<span class="target" id="index-4"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATHEXT</span></code></td>
<td>0</td>
</tr>
<tr class="row-even"><td>Shortcuts</td>
<td>Create shortcuts for the interpreter,
documentation and IDLE if installed.</td>
<td>1</td>
</tr>
<tr class="row-odd"><td>Include_doc</td>
<td>Install Python manual</td>
<td>1</td>
</tr>
<tr class="row-even"><td>Include_debug</td>
<td>Install debug binaries</td>
<td>0</td>
</tr>
<tr class="row-odd"><td>Include_dev</td>
<td>Install developer headers and
libraries</td>
<td>1</td>
</tr>
<tr class="row-even"><td>Include_exe</td>
<td>Install <code class="file docutils literal"><span class="pre">python.exe</span></code> and
related files</td>
<td>1</td>
</tr>
<tr class="row-odd"><td>Include_launcher</td>
<td>Install <a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a>.</td>
<td>1</td>
</tr>
<tr class="row-even"><td>InstallLauncherAllUsers</td>
<td>Installs <a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a> for all
users.</td>
<td>1</td>
</tr>
<tr class="row-odd"><td>Include_lib</td>
<td>Install standard library and
extension modules</td>
<td>1</td>
</tr>
<tr class="row-even"><td>Include_pip</td>
<td>Install bundled pip and setuptools</td>
<td>1</td>
</tr>
<tr class="row-odd"><td>Include_symbols</td>
<td>Install debugging symbols (<cite>*</cite>.pdb)</td>
<td>0</td>
</tr>
<tr class="row-even"><td>Include_tcltk</td>
<td>Install Tcl/Tk support and IDLE</td>
<td>1</td>
</tr>
<tr class="row-odd"><td>Include_test</td>
<td>Install standard library test suite</td>
<td>1</td>
</tr>
<tr class="row-even"><td>Include_tools</td>
<td>Install utility scripts</td>
<td>1</td>
</tr>
<tr class="row-odd"><td>LauncherOnly</td>
<td>Only installs the launcher. This
will override most other options.</td>
<td>0</td>
</tr>
<tr class="row-even"><td>SimpleInstall</td>
<td>Disable most install UI</td>
<td>0</td>
</tr>
<tr class="row-odd"><td>SimpleInstallDescription</td>
<td>A custom message to display when the
simplified install UI is used.</td>
<td>(empty)</td>
</tr>
</tbody>
</table>
<p>For example, to silently install a default, system-wide Python installation,
you could use the following command (from an elevated command prompt):</p>
<div class="highlight-none"><div class="highlight"><pre>python-3.5.0.exe /quiet InstallAllUsers=1 PrependPath=1 Include_test=0
</pre></div>
</div>
<p>To allow users to easily install a personal copy of Python without the test
suite, you could provide a shortcut with the following command. This will
display a simplified initial page and disallow customization:</p>
<div class="highlight-none"><div class="highlight"><pre>python-3.5.0.exe InstallAllUsers=0 Include_launcher=0 Include_test=0
    SimpleInstall=1 SimpleInstallDescription=&quot;Just for me, no test suite.&quot;
</pre></div>
</div>
<p>(Note that omitting the launcher also omits file associations, and is only
recommended for per-user installs when there is also a system-wide installation
that included the launcher.)</p>
<p>The options listed above can also be provided in a file named <code class="docutils literal"><span class="pre">unattend.xml</span></code>
alongside the executable. This file specifies a list of options and values.
When a value is provided as an attribute, it will be converted to a number if
possible. Values provided as element text are always left as strings. This
example file sets the same options and the previous example:</p>
<div class="highlight-none"><div class="highlight"><pre>&lt;Options&gt;
    &lt;Option Name=&quot;InstallAllUsers&quot; Value=&quot;no&quot; /&gt;
    &lt;Option Name=&quot;Include_launcher&quot; Value=&quot;0&quot; /&gt;
    &lt;Option Name=&quot;Include_test&quot; Value=&quot;no&quot; /&gt;
    &lt;Option Name=&quot;SimpleInstall&quot; Value=&quot;yes&quot; /&gt;
    &lt;Option Name=&quot;SimpleInstallDescription&quot;&gt;Just for me, no test suite&lt;/Option&gt;
&lt;/Options&gt;
</pre></div>
</div>
</div>
<div class="section" id="installing-without-downloading">
<span id="install-layout-option"></span><h3>3.1.4. Installing Without Downloading<a class="headerlink" href="#installing-without-downloading" title="Permalink to this headline">¶</a></h3>
<p>As some features of Python are not included in the initial installer download,
selecting those features may require an internet connection.  To avoid this
need, all possible components may be downloaded on-demand to create a complete
<em>layout</em> that will no longer require an internet connection regardless of the
selected features. Note that this download may be bigger than required, but
where a large number of installations are going to be performed it is very
useful to have a locally cached copy.</p>
<p>Execute the following command from Command Prompt to download all possible
required files.  Remember to substitute <code class="docutils literal"><span class="pre">python-3.5.0.exe</span></code> for the actual
name of your installer, and to create layouts in their own directories to
avoid collisions between files with the same name.</p>
<div class="highlight-none"><div class="highlight"><pre>python-3.5.0.exe /layout [optional target directory]
</pre></div>
</div>
<p>You may also specify the <code class="docutils literal"><span class="pre">/quiet</span></code> option to hide the progress display.</p>
</div>
<div class="section" id="modifying-an-install">
<h3>3.1.5. Modifying an install<a class="headerlink" href="#modifying-an-install" title="Permalink to this headline">¶</a></h3>
<p>Once Python has been installed, you can add or remove features through the
Programs and Features tool that is part of Windows. Select the Python entry and
choose &#8220;Uninstall/Change&#8221; to open the installer in maintenance mode.</p>
<p>&#8220;Modify&#8221; allows you to add or remove features by modifying the checkboxes -
unchanged checkboxes will not install or remove anything. Some options cannot be
changed in this mode, such as the install directory; to modify these, you will
need to remove and then reinstall Python completely.</p>
<p>&#8220;Repair&#8221; will verify all the files that should be installed using the current
settings and replace any that have been removed or modified.</p>
<p>&#8220;Uninstall&#8221; will remove Python entirely, with the exception of the
<a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a>, which has its own entry in Programs and Features.</p>
</div>
<div class="section" id="other-platforms">
<h3>3.1.6. Other Platforms<a class="headerlink" href="#other-platforms" title="Permalink to this headline">¶</a></h3>
<p>With ongoing development of Python, some platforms that used to be supported
earlier are no longer supported (due to the lack of users or developers).
Check <span class="target" id="index-5"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0011"><strong>PEP 11</strong></a> for details on all unsupported platforms.</p>
<ul class="simple">
<li><a class="reference external" href="http://pythonce.sourceforge.net/">Windows CE</a> is still supported.</li>
<li>The <a class="reference external" href="http://cygwin.com/">Cygwin</a> installer offers to install the Python
interpreter as well (cf. <a class="reference external" href="ftp://ftp.uni-erlangen.de/pub/pc/gnuwin32/cygwin/mirrors/cygnus/release/python">Cygwin package source</a>, <a class="reference external" href="http://www.tishler.net/jason/software/python/">Maintainer releases</a>)</li>
</ul>
<p>See <a class="reference external" href="https://www.python.org/download/windows/">Python for Windows</a>
for detailed information about platforms with pre-compiled installers.</p>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><a class="reference external" href="http://www.richarddooling.com/index.php/2006/03/14/python-on-xp-7-minutes-to-hello-world/">Python on XP</a></dt>
<dd>&#8220;7 Minutes to &#8220;Hello World!&#8221;&#8221;
by Richard Dooling, 2006</dd>
<dt><a class="reference external" href="http://www.diveintopython.net/installing_python/windows.html">Installing on Windows</a></dt>
<dd>in &#8220;<a class="reference external" href="http://www.diveintopython.net/">Dive into Python: Python from novice to pro</a>&#8221;
by Mark Pilgrim, 2004,
ISBN 1-59059-356-1</dd>
<dt><a class="reference external" href="http://www.swaroopch.com/notes/python/#install_windows">For Windows users</a></dt>
<dd>in &#8220;Installing Python&#8221;
in &#8220;<a class="reference external" href="http://www.swaroopch.com/notes/python/">A Byte of Python</a>&#8221;
by Swaroop C H, 2003</dd>
</dl>
</div>
</div>
</div>
<div class="section" id="alternative-bundles">
<h2>3.2. Alternative bundles<a class="headerlink" href="#alternative-bundles" title="Permalink to this headline">¶</a></h2>
<p>Besides the standard CPython distribution, there are modified packages including
additional functionality.  The following is a list of popular versions and their
key features:</p>
<dl class="docutils">
<dt><a class="reference external" href="http://www.activestate.com/activepython/">ActivePython</a></dt>
<dd>Installer with multi-platform compatibility, documentation, PyWin32</dd>
<dt><a class="reference external" href="http://www.continuum.io/downloads/">Anaconda</a></dt>
<dd>Popular scientific modules (such as numpy, scipy and pandas) and the
<code class="docutils literal"><span class="pre">conda</span></code> package manager.</dd>
<dt><a class="reference external" href="https://www.enthought.com/products/canopy/">Canopy</a></dt>
<dd>A &#8220;comprehensive Python analysis environment&#8221; with editors and other
development tools.</dd>
<dt><a class="reference external" href="https://winpython.github.io/">WinPython</a></dt>
<dd>Windows-specific distribution with prebuilt scientific packages and
tools for building packages.</dd>
</dl>
<p>Note that these packages may not include the latest versions of Python or
other libraries, and are not maintained or supported by the core Python team.</p>
</div>
<div class="section" id="configuring-python">
<h2>3.3. Configuring Python<a class="headerlink" href="#configuring-python" title="Permalink to this headline">¶</a></h2>
<p>To run Python conveniently from a command prompt, you might consider changing
some default environment variables in Windows.  While the installer provides an
option to configure the PATH and PATHEXT variables for you, this is only
reliable for a single, system-wide installation.  If you regularly use multiple
versions of Python, consider using the <a class="reference internal" href="#launcher"><span>Python Launcher for Windows</span></a>.</p>
<div class="section" id="excursus-setting-environment-variables">
<span id="setting-envvars"></span><h3>3.3.1. Excursus: Setting environment variables<a class="headerlink" href="#excursus-setting-environment-variables" title="Permalink to this headline">¶</a></h3>
<p>Windows allows environment variables to be configured permanently at both the
User level and the System level, or temporarily in a command prompt.</p>
<p>To temporarily set environment variables, open Command Prompt and use the
<strong class="command">set</strong> command:</p>
<div class="highlight-none"><div class="highlight"><pre>C:\&gt;set PATH=C:\Program Files\Python 3.5;%PATH%
C:\&gt;set PYTHONPATH=%PYTHONPATH%;C:\My_python_lib
C:\&gt;python
</pre></div>
</div>
<p>These changes will apply to any further commands executed in that console, and
will be inherited by any applications started from the console.</p>
<p>Including the variable name within percent signs will expand to the existing
value, allowing you to add your new value at either the start or the end.
Modifying <span class="target" id="index-6"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> by adding the directory containing
<strong class="program">python.exe</strong> to the start is a common way to ensure the correct version
of Python is launched.</p>
<p>To permanently modify the default environment variables, click Start and search
for &#8216;edit environment variables&#8217;, or open System properties, <span class="guilabel">Advanced
system settings</span> and click the <span class="guilabel">Environment Variables</span> button.
In this dialog, you can add or modify User and System variables. To change
System variables, you need non-restricted access to your machine
(i.e. Administrator rights).</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p>Windows will concatenate User variables <em>after</em> System variables, which may
cause unexpected results when modifying <span class="target" id="index-7"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code>.</p>
<p class="last">The <span class="target" id="index-8"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONPATH"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONPATH</span></code></a> variable is used by all versions of Python 2 and
Python 3, so you should not permanently configure this variable unless it
only includes code that is compatible with all of your installed Python
versions.</p>
</div>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><a class="reference external" href="http://support.microsoft.com/kb/100843">http://support.microsoft.com/kb/100843</a></dt>
<dd>Environment variables in Windows NT</dd>
<dt><a class="reference external" href="http://technet.microsoft.com/en-us/library/cc754250.aspx">http://technet.microsoft.com/en-us/library/cc754250.aspx</a></dt>
<dd>The SET command, for temporarily modifying environment variables</dd>
<dt><a class="reference external" href="http://technet.microsoft.com/en-us/library/cc755104.aspx">http://technet.microsoft.com/en-us/library/cc755104.aspx</a></dt>
<dd>The SETX command, for permanently modifying environment variables</dd>
<dt><a class="reference external" href="http://support.microsoft.com/kb/310519">http://support.microsoft.com/kb/310519</a></dt>
<dd>How To Manage Environment Variables in Windows XP</dd>
<dt><a class="reference external" href="http://www.chem.gla.ac.uk/~louis/software/faq/q1.html">http://www.chem.gla.ac.uk/~louis/software/faq/q1.html</a></dt>
<dd>Setting Environment variables, Louis J. Farrugia</dd>
</dl>
</div>
</div>
<div class="section" id="finding-the-python-executable">
<span id="windows-path-mod"></span><h3>3.3.2. Finding the Python executable<a class="headerlink" href="#finding-the-python-executable" title="Permalink to this headline">¶</a></h3>
<div class="versionchanged">
<p><span class="versionmodified">Changed in version 3.5.</span></p>
</div>
<p>Besides using the automatically created start menu entry for the Python
interpreter, you might want to start Python in the command prompt. The
installer for Python 3.5 and later has an option to set that up for you.</p>
<p>On the first page of the installer, an option labelled &#8220;Add Python 3.5 to
PATH&#8221; can be selected to have the installer add the install location into the
<span class="target" id="index-9"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code>.  The location of the <code class="file docutils literal"><span class="pre">Scripts\</span></code> folder is also added.
This allows you to type <strong class="command">python</strong> to run the interpreter, and
<strong class="command">pip</strong> or . Thus, you can also execute your
scripts with command line options, see <a class="reference internal" href="cmdline.html#using-on-cmdline"><span>Command line</span></a> documentation.</p>
<p>If you don&#8217;t enable this option at install time, you can always re-run the
installer, select Modify, and enable it.  Alternatively, you can manually
modify the <span class="target" id="index-10"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> using the directions in <a class="reference internal" href="#setting-envvars"><span>Excursus: Setting environment variables</span></a>.  You
need to set your <span class="target" id="index-11"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> environment variable to include the directory
of your Python installation, delimited by a semicolon from other entries.  An
example variable could look like this (assuming the first two entries already
existed):</p>
<div class="highlight-none"><div class="highlight"><pre>C:\WINDOWS\system32;C:\WINDOWS;C:\Program Files\Python 3.5
</pre></div>
</div>
</div>
</div>
<div class="section" id="python-launcher-for-windows">
<span id="launcher"></span><h2>3.4. Python Launcher for Windows<a class="headerlink" href="#python-launcher-for-windows" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.3.</span></p>
</div>
<p>The Python launcher for Windows is a utility which aids in locating and
executing of different Python versions.  It allows scripts (or the
command-line) to indicate a preference for a specific Python version, and
will locate and execute that version.</p>
<p>Unlike the <span class="target" id="index-12"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> variable, the launcher will correctly select the most
appropriate version of Python. It will prefer per-user installations over
system-wide ones, and orders by language version rather than using the most
recently installed version.</p>
<div class="section" id="getting-started">
<h3>3.4.1. Getting started<a class="headerlink" href="#getting-started" title="Permalink to this headline">¶</a></h3>
<div class="section" id="from-the-command-line">
<h4>3.4.1.1. From the command-line<a class="headerlink" href="#from-the-command-line" title="Permalink to this headline">¶</a></h4>
<p>System-wide installations of Python 3.3 and later will put the launcher on your
<span class="target" id="index-13"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code>. The launcher is compatible with all available versions of
Python, so it does not matter which version is installed. To check that the
launcher is available, execute the following command in Command Prompt:</p>
<div class="highlight-none"><div class="highlight"><pre>py
</pre></div>
</div>
<p>You should find that the latest version of Python 2.x you have installed is
started - it can be exited as normal, and any additional command-line
arguments specified will be sent directly to Python.</p>
<p>If you have multiple versions of Python 2.x installed (e.g., 2.6 and 2.7) you
will have noticed that Python 2.7 was started - to launch Python 2.6, try the
command:</p>
<div class="highlight-none"><div class="highlight"><pre>py -2.6
</pre></div>
</div>
<p>If you have a Python 3.x installed, try the command:</p>
<div class="highlight-none"><div class="highlight"><pre>py -3
</pre></div>
</div>
<p>You should find the latest version of Python 3.x starts.</p>
<p>If you see the following error, you do not have the launcher installed:</p>
<div class="highlight-none"><div class="highlight"><pre>&#39;py&#39; is not recognized as an internal or external command,
operable program or batch file.
</pre></div>
</div>
<p>Per-user installations of Python do not add the launcher to <span class="target" id="index-14"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code>
unless the option was selected on installation.</p>
</div>
<div class="section" id="virtual-environments">
<h4>3.4.1.2. Virtual environments<a class="headerlink" href="#virtual-environments" title="Permalink to this headline">¶</a></h4>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
<p>If the launcher is run with no explicit Python version specification, and a
virtual environment (created with the standard library <a class="reference internal" href="../library/venv.html#module-venv" title="venv: Creation of virtual environments."><code class="xref py py-mod docutils literal"><span class="pre">venv</span></code></a> module or
the external <code class="docutils literal"><span class="pre">virtualenv</span></code> tool) active, the launcher will run the virtual
environment&#8217;s interpreter rather than the global one.  To run the global
interpreter, either deactivate the virtual environment, or explicitly specify
the global Python version.</p>
</div>
<div class="section" id="from-a-script">
<h4>3.4.1.3. From a script<a class="headerlink" href="#from-a-script" title="Permalink to this headline">¶</a></h4>
<p>Let&#8217;s create a test Python script - create a file called <code class="docutils literal"><span class="pre">hello.py</span></code> with the
following contents</p>
<div class="highlight-none"><div class="highlight"><pre>#! python
import sys
sys.stdout.write(&quot;hello from Python %s\n&quot; % (sys.version,))
</pre></div>
</div>
<p>From the directory in which hello.py lives, execute the command:</p>
<div class="highlight-none"><div class="highlight"><pre>py hello.py
</pre></div>
</div>
<p>You should notice the version number of your latest Python 2.x installation
is printed.  Now try changing the first line to be:</p>
<div class="highlight-none"><div class="highlight"><pre>#! python3
</pre></div>
</div>
<p>Re-executing the command should now print the latest Python 3.x information.
As with the above command-line examples, you can specify a more explicit
version qualifier.  Assuming you have Python 2.6 installed, try changing the
first line to <code class="docutils literal"><span class="pre">#!</span> <span class="pre">python2.6</span></code> and you should find the 2.6 version
information printed.</p>
</div>
<div class="section" id="from-file-associations">
<h4>3.4.1.4. From file associations<a class="headerlink" href="#from-file-associations" title="Permalink to this headline">¶</a></h4>
<p>The launcher should have been associated with Python files (i.e. <code class="docutils literal"><span class="pre">.py</span></code>,
<code class="docutils literal"><span class="pre">.pyw</span></code>, <code class="docutils literal"><span class="pre">.pyc</span></code> files) when it was installed.  This means that
when you double-click on one of these files from Windows explorer the launcher
will be used, and therefore you can use the same facilities described above to
have the script specify the version which should be used.</p>
<p>The key benefit of this is that a single launcher can support multiple Python
versions at the same time depending on the contents of the first line.</p>
</div>
</div>
<div class="section" id="shebang-lines">
<h3>3.4.2. Shebang Lines<a class="headerlink" href="#shebang-lines" title="Permalink to this headline">¶</a></h3>
<p>If the first line of a script file starts with <code class="docutils literal"><span class="pre">#!</span></code>, it is known as a
&#8220;shebang&#8221; line.  Linux and other Unix like operating systems have native
support for such lines and are commonly used on such systems to indicate how
a script should be executed.  This launcher allows the same facilities to be
using with Python scripts on Windows and the examples above demonstrate their
use.</p>
<p>To allow shebang lines in Python scripts to be portable between Unix and
Windows, this launcher supports a number of &#8216;virtual&#8217; commands to specify
which interpreter to use.  The supported virtual commands are:</p>
<ul class="simple">
<li><code class="docutils literal"><span class="pre">/usr/bin/env</span> <span class="pre">python</span></code></li>
<li><code class="docutils literal"><span class="pre">/usr/bin/python</span></code></li>
<li><code class="docutils literal"><span class="pre">/usr/local/bin/python</span></code></li>
<li><code class="docutils literal"><span class="pre">python</span></code></li>
</ul>
<p>For example, if the first line of your script starts with</p>
<div class="highlight-none"><div class="highlight"><pre>#! /usr/bin/python
</pre></div>
</div>
<p>The default Python will be located and used.  As many Python scripts written
to work on Unix will already have this line, you should find these scripts can
be used by the launcher without modification.  If you are writing a new script
on Windows which you hope will be useful on Unix, you should use one of the
shebang lines starting with <code class="docutils literal"><span class="pre">/usr</span></code>.</p>
<p>Any of the above virtual commands can be suffixed with an explicit version
(either just the major version, or the major and minor version) - for example
<code class="docutils literal"><span class="pre">/usr/bin/python2.7</span></code> - which will cause that specific version to be located
and used.</p>
<p>The <code class="docutils literal"><span class="pre">/usr/bin/env</span></code> form of shebang line has one further special property.
Before looking for installed Python interpreters, this form will search the
executable <span class="target" id="index-15"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> for a Python executable. This corresponds to the
behaviour of the Unix <code class="docutils literal"><span class="pre">env</span></code> program, which performs a <span class="target" id="index-16"></span><code class="xref std std-envvar docutils literal"><span class="pre">PATH</span></code> search.</p>
</div>
<div class="section" id="arguments-in-shebang-lines">
<h3>3.4.3. Arguments in shebang lines<a class="headerlink" href="#arguments-in-shebang-lines" title="Permalink to this headline">¶</a></h3>
<p>The shebang lines can also specify additional options to be passed to the
Python interpreter.  For example, if you have a shebang line:</p>
<div class="highlight-none"><div class="highlight"><pre>#! /usr/bin/python -v
</pre></div>
</div>
<p>Then Python will be started with the <code class="docutils literal"><span class="pre">-v</span></code> option</p>
</div>
<div class="section" id="customization">
<h3>3.4.4. Customization<a class="headerlink" href="#customization" title="Permalink to this headline">¶</a></h3>
<div class="section" id="customization-via-ini-files">
<h4>3.4.4.1. Customization via INI files<a class="headerlink" href="#customization-via-ini-files" title="Permalink to this headline">¶</a></h4>
<p>Two .ini files will be searched by the launcher - <code class="docutils literal"><span class="pre">py.ini</span></code> in the current
user&#8217;s &#8220;application data&#8221; directory (i.e. the directory returned by calling the
Windows function SHGetFolderPath with CSIDL_LOCAL_APPDATA) and <code class="docutils literal"><span class="pre">py.ini</span></code> in the
same directory as the launcher. The same .ini files are used for both the
&#8216;console&#8217; version of the launcher (i.e. py.exe) and for the &#8216;windows&#8217; version
(i.e. pyw.exe)</p>
<p>Customization specified in the &#8220;application directory&#8221; will have precedence over
the one next to the executable, so a user, who may not have write access to the
.ini file next to the launcher, can override commands in that global .ini file)</p>
</div>
<div class="section" id="customizing-default-python-versions">
<h4>3.4.4.2. Customizing default Python versions<a class="headerlink" href="#customizing-default-python-versions" title="Permalink to this headline">¶</a></h4>
<p>In some cases, a version qualifier can be included in a command to dictate
which version of Python will be used by the command. A version qualifier
starts with a major version number and can optionally be followed by a period
(&#8216;.&#8217;) and a minor version specifier. If the minor qualifier is specified, it
may optionally be followed by &#8220;-32&#8221; to indicate the 32-bit implementation of
that version be used.</p>
<p>For example, a shebang line of <code class="docutils literal"><span class="pre">#!python</span></code> has no version qualifier, while
<code class="docutils literal"><span class="pre">#!python3</span></code> has a version qualifier which specifies only a major version.</p>
<p>If no version qualifiers are found in a command, the environment variable
<code class="docutils literal"><span class="pre">PY_PYTHON</span></code> can be set to specify the default version qualifier - the default
value is &#8220;2&#8221;. Note this value could specify just a major version (e.g. &#8220;2&#8221;) or
a major.minor qualifier (e.g. &#8220;2.6&#8221;), or even major.minor-32.</p>
<p>If no minor version qualifiers are found, the environment variable
<code class="docutils literal"><span class="pre">PY_PYTHON{major}</span></code> (where <code class="docutils literal"><span class="pre">{major}</span></code> is the current major version qualifier
as determined above) can be set to specify the full version. If no such option
is found, the launcher will enumerate the installed Python versions and use
the latest minor release found for the major version, which is likely,
although not guaranteed, to be the most recently installed version in that
family.</p>
<p>On 64-bit Windows with both 32-bit and 64-bit implementations of the same
(major.minor) Python version installed, the 64-bit version will always be
preferred. This will be true for both 32-bit and 64-bit implementations of the
launcher - a 32-bit launcher will prefer to execute a 64-bit Python installation
of the specified version if available. This is so the behavior of the launcher
can be predicted knowing only what versions are installed on the PC and
without regard to the order in which they were installed (i.e., without knowing
whether a 32 or 64-bit version of Python and corresponding launcher was
installed last). As noted above, an optional &#8220;-32&#8221; suffix can be used on a
version specifier to change this behaviour.</p>
<p>Examples:</p>
<ul class="simple">
<li>If no relevant options are set, the commands <code class="docutils literal"><span class="pre">python</span></code> and
<code class="docutils literal"><span class="pre">python2</span></code> will use the latest Python 2.x version installed and
the command <code class="docutils literal"><span class="pre">python3</span></code> will use the latest Python 3.x installed.</li>
<li>The commands <code class="docutils literal"><span class="pre">python3.1</span></code> and <code class="docutils literal"><span class="pre">python2.7</span></code> will not consult any
options at all as the versions are fully specified.</li>
<li>If <code class="docutils literal"><span class="pre">PY_PYTHON=3</span></code>, the commands <code class="docutils literal"><span class="pre">python</span></code> and <code class="docutils literal"><span class="pre">python3</span></code> will both use
the latest installed Python 3 version.</li>
<li>If <code class="docutils literal"><span class="pre">PY_PYTHON=3.1-32</span></code>, the command <code class="docutils literal"><span class="pre">python</span></code> will use the 32-bit
implementation of 3.1 whereas the command <code class="docutils literal"><span class="pre">python3</span></code> will use the latest
installed Python (PY_PYTHON was not considered at all as a major
version was specified.)</li>
<li>If <code class="docutils literal"><span class="pre">PY_PYTHON=3</span></code> and <code class="docutils literal"><span class="pre">PY_PYTHON3=3.1</span></code>, the commands
<code class="docutils literal"><span class="pre">python</span></code> and <code class="docutils literal"><span class="pre">python3</span></code> will both use specifically 3.1</li>
</ul>
<p>In addition to environment variables, the same settings can be configured
in the .INI file used by the launcher.  The section in the INI file is
called <code class="docutils literal"><span class="pre">[defaults]</span></code> and the key name will be the same as the
environment variables without the leading <code class="docutils literal"><span class="pre">PY_</span></code> prefix (and note that
the key names in the INI file are case insensitive.)  The contents of
an environment variable will override things specified in the INI file.</p>
<p>For example:</p>
<ul class="simple">
<li>Setting <code class="docutils literal"><span class="pre">PY_PYTHON=3.1</span></code> is equivalent to the INI file containing:</li>
</ul>
<div class="highlight-none"><div class="highlight"><pre>[defaults]
python=3.1
</pre></div>
</div>
<ul class="simple">
<li>Setting <code class="docutils literal"><span class="pre">PY_PYTHON=3</span></code> and <code class="docutils literal"><span class="pre">PY_PYTHON3=3.1</span></code> is equivalent to the INI file
containing:</li>
</ul>
<div class="highlight-none"><div class="highlight"><pre>[defaults]
python=3
python3=3.1
</pre></div>
</div>
</div>
</div>
<div class="section" id="diagnostics">
<h3>3.4.5. Diagnostics<a class="headerlink" href="#diagnostics" title="Permalink to this headline">¶</a></h3>
<p>If an environment variable <code class="docutils literal"><span class="pre">PYLAUNCH_DEBUG</span></code> is set (to any value), the
launcher will print diagnostic information to stderr (i.e. to the console).
While this information manages to be simultaneously verbose <em>and</em> terse, it
should allow you to see what versions of Python were located, why a
particular version was chosen and the exact command-line used to execute the
target Python.</p>
</div>
</div>
<div class="section" id="finding-modules">
<h2>3.5. Finding modules<a class="headerlink" href="#finding-modules" title="Permalink to this headline">¶</a></h2>
<p>Python usually stores its library (and thereby your site-packages folder) in the
installation directory.  So, if you had installed Python to
<code class="file docutils literal"><span class="pre">C:\Python\</span></code>, the default library would reside in
<code class="file docutils literal"><span class="pre">C:\Python\Lib\</span></code> and third-party modules should be stored in
<code class="file docutils literal"><span class="pre">C:\Python\Lib\site-packages\</span></code>.</p>
<p>This is how <a class="reference internal" href="../library/sys.html#sys.path" title="sys.path"><code class="xref py py-data docutils literal"><span class="pre">sys.path</span></code></a> is populated on Windows:</p>
<ul class="simple">
<li>An empty entry is added at the start, which corresponds to the current
directory.</li>
<li>If the environment variable <span class="target" id="index-17"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONPATH"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONPATH</span></code></a> exists, as described in
<a class="reference internal" href="cmdline.html#using-on-envvars"><span>Environment variables</span></a>, its entries are added next.  Note that on Windows,
paths in this variable must be separated by semicolons, to distinguish them
from the colon used in drive identifiers (<code class="docutils literal"><span class="pre">C:\</span></code> etc.).</li>
<li>Additional &#8220;application paths&#8221; can be added in the registry as subkeys of
<code class="samp docutils literal"><span class="pre">\SOFTWARE\Python\PythonCore\</span><em><span class="pre">version</span></em><span class="pre">\PythonPath</span></code> under both the
<code class="docutils literal"><span class="pre">HKEY_CURRENT_USER</span></code> and <code class="docutils literal"><span class="pre">HKEY_LOCAL_MACHINE</span></code> hives.  Subkeys which have
semicolon-delimited path strings as their default value will cause each path
to be added to <a class="reference internal" href="../library/sys.html#sys.path" title="sys.path"><code class="xref py py-data docutils literal"><span class="pre">sys.path</span></code></a>.  (Note that all known installers only use
HKLM, so HKCU is typically empty.)</li>
<li>If the environment variable <span class="target" id="index-18"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONHOME"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONHOME</span></code></a> is set, it is assumed as
&#8220;Python Home&#8221;.  Otherwise, the path of the main Python executable is used to
locate a &#8220;landmark file&#8221; (<code class="docutils literal"><span class="pre">Lib\os.py</span></code>) to deduce the &#8220;Python Home&#8221;.  If a
Python home is found, the relevant sub-directories added to <a class="reference internal" href="../library/sys.html#sys.path" title="sys.path"><code class="xref py py-data docutils literal"><span class="pre">sys.path</span></code></a>
(<code class="docutils literal"><span class="pre">Lib</span></code>, <code class="docutils literal"><span class="pre">plat-win</span></code>, etc) are based on that folder.  Otherwise, the core
Python path is constructed from the PythonPath stored in the registry.</li>
<li>If the Python Home cannot be located, no <span class="target" id="index-19"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONPATH"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONPATH</span></code></a> is specified in
the environment, and no registry entries can be found, a default path with
relative entries is used (e.g. <code class="docutils literal"><span class="pre">.\Lib;.\plat-win</span></code>, etc).</li>
</ul>
<p>If a <code class="docutils literal"><span class="pre">pyvenv.cfg</span></code> file is found alongside the main executable or in the
directory one level above the executable, the following variations apply:</p>
<ul class="simple">
<li>If <code class="docutils literal"><span class="pre">home</span></code> is an absolute path and <span class="target" id="index-20"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONHOME"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONHOME</span></code></a> is not set, this
path is used instead of the path to the main executable when deducing the
home location.</li>
<li>If <code class="docutils literal"><span class="pre">applocal</span></code> is set to true, the <code class="docutils literal"><span class="pre">home</span></code> property or the main executable
is always used as the home path, and all environment variables or registry
values affecting the path are ignored. The landmark file is not checked.</li>
</ul>
<p>The end result of all this is:</p>
<ul class="simple">
<li>When running <code class="file docutils literal"><span class="pre">python.exe</span></code>, or any other .exe in the main Python
directory (either an installed version, or directly from the PCbuild
directory), the core path is deduced, and the core paths in the registry are
ignored.  Other &#8220;application paths&#8221; in the registry are always read.</li>
<li>When Python is hosted in another .exe (different directory, embedded via COM,
etc), the &#8220;Python Home&#8221; will not be deduced, so the core path from the
registry is used.  Other &#8220;application paths&#8221; in the registry are always read.</li>
<li>If Python can&#8217;t find its home and there are no registry value (frozen .exe,
some very strange installation setup) you get a path with some default, but
relative, paths.</li>
</ul>
<p>For those who want to bundle Python into their application or distribution, the
following advice will prevent conflicts with other installations:</p>
<ul class="simple">
<li>Include a <code class="docutils literal"><span class="pre">pyvenv.cfg</span></code> file alongside your executable containing
<code class="docutils literal"><span class="pre">applocal</span> <span class="pre">=</span> <span class="pre">true</span></code>. This will ensure that your own directory will be used to
resolve paths even if you have included the standard library in a ZIP file.
It will also ignore user site-packages and other paths listed in the
registry.</li>
<li>If you are loading <code class="file docutils literal"><span class="pre">python3.dll</span></code> or <code class="file docutils literal"><span class="pre">python35.dll</span></code> in your own
executable, explicitly call <a class="reference internal" href="../c-api/init.html#c.Py_SetPath" title="Py_SetPath"><code class="xref c c-func docutils literal"><span class="pre">Py_SetPath()</span></code></a> or (at least)
<a class="reference internal" href="../c-api/init.html#c.Py_SetProgramName" title="Py_SetProgramName"><code class="xref c c-func docutils literal"><span class="pre">Py_SetProgramName()</span></code></a> before <a class="reference internal" href="../c-api/init.html#c.Py_Initialize" title="Py_Initialize"><code class="xref c c-func docutils literal"><span class="pre">Py_Initialize()</span></code></a>.</li>
<li>Clear and/or overwrite <span class="target" id="index-21"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONPATH"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONPATH</span></code></a> and set <span class="target" id="index-22"></span><a class="reference internal" href="cmdline.html#envvar-PYTHONHOME"><code class="xref std std-envvar docutils literal"><span class="pre">PYTHONHOME</span></code></a>
before launching <code class="file docutils literal"><span class="pre">python.exe</span></code> from your application.</li>
<li>If you cannot use the previous suggestions (for example, you are a
distribution that allows people to run <code class="file docutils literal"><span class="pre">python.exe</span></code> directly), ensure
that the landmark file (<code class="file docutils literal"><span class="pre">Lib\os.py</span></code>) exists in your install directory.
(Note that it will not be detected inside a ZIP file.)</li>
</ul>
<p>These will ensure that the files in a system-wide installation will not take
precedence over the copy of the standard library bundled with your application.
Otherwise, your users may experience problems using your application. Note that
the first suggestion is the best, as the other may still be susceptible to
non-standard paths in the registry and user site-packages.</p>
</div>
<div class="section" id="additional-modules">
<h2>3.6. Additional modules<a class="headerlink" href="#additional-modules" title="Permalink to this headline">¶</a></h2>
<p>Even though Python aims to be portable among all platforms, there are features
that are unique to Windows.  A couple of modules, both in the standard library
and external, and snippets exist to use these features.</p>
<p>The Windows-specific standard modules are documented in
<a class="reference internal" href="../library/windows.html#mswin-specific-services"><span>MS Windows Specific Services</span></a>.</p>
<div class="section" id="pywin32">
<h3>3.6.1. PyWin32<a class="headerlink" href="#pywin32" title="Permalink to this headline">¶</a></h3>
<p>The <a class="reference external" href="http://python.net/crew/mhammond/win32/">PyWin32</a> module by Mark Hammond
is a collection of modules for advanced Windows-specific support.  This includes
utilities for:</p>
<ul class="simple">
<li><a class="reference external" href="http://www.microsoft.com/com/">Component Object Model</a> (COM)</li>
<li>Win32 API calls</li>
<li>Registry</li>
<li>Event log</li>
<li><a class="reference external" href="http://msdn.microsoft.com/en-us/library/fe1cf721%28VS.80%29.aspx">Microsoft Foundation Classes</a> (MFC)
user interfaces</li>
</ul>
<p><a class="reference external" href="http://web.archive.org/web/20060524042422/https://www.python.org/windows/pythonwin/">PythonWin</a> is a sample MFC application
shipped with PyWin32.  It is an embeddable IDE with a built-in debugger.</p>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><a class="reference external" href="http://timgolden.me.uk/python/win32_how_do_i.html">Win32 How Do I...?</a></dt>
<dd>by Tim Golden</dd>
<dt><a class="reference external" href="http://www.boddie.org.uk/python/COM.html">Python and COM</a></dt>
<dd>by David and Paul Boddie</dd>
</dl>
</div>
</div>
<div class="section" id="cx-freeze">
<h3>3.6.2. cx_Freeze<a class="headerlink" href="#cx-freeze" title="Permalink to this headline">¶</a></h3>
<p><a class="reference external" href="http://cx-freeze.sourceforge.net/">cx_Freeze</a> is a <a class="reference internal" href="../library/distutils.html#module-distutils" title="distutils: Support for building and installing Python modules into an existing Python installation."><code class="xref py py-mod docutils literal"><span class="pre">distutils</span></code></a>
extension (see <a class="reference internal" href="../distutils/extending.html#extending-distutils"><span>Extending Distutils</span></a>) which wraps Python scripts into
executable Windows programs (<code class="file docutils literal"><em><span class="pre">*</span></em><span class="pre">.exe</span></code> files).  When you have done this,
you can distribute your application without requiring your users to install
Python.</p>
</div>
<div class="section" id="wconio">
<h3>3.6.3. WConio<a class="headerlink" href="#wconio" title="Permalink to this headline">¶</a></h3>
<p>Since Python&#8217;s advanced terminal handling layer, <a class="reference internal" href="../library/curses.html#module-curses" title="curses: An interface to the curses library, providing portable terminal handling. (Unix)"><code class="xref py py-mod docutils literal"><span class="pre">curses</span></code></a>, is restricted to
Unix-like systems, there is a library exclusive to Windows as well: Windows
Console I/O for Python.</p>
<p><a class="reference external" href="http://newcenturycomputers.net/projects/wconio.html">WConio</a> is a wrapper for
Turbo-C&#8217;s <code class="file docutils literal"><span class="pre">CONIO.H</span></code>, used to create text user interfaces.</p>
</div>
</div>
<div class="section" id="compiling-python-on-windows">
<h2>3.7. Compiling Python on Windows<a class="headerlink" href="#compiling-python-on-windows" title="Permalink to this headline">¶</a></h2>
<p>If you want to compile CPython yourself, first thing you should do is get the
<a class="reference external" href="https://www.python.org/download/source/">source</a>. You can download either the
latest release&#8217;s source or just grab a fresh <a class="reference external" href="https://docs.python.org/devguide/setup.html#getting-the-source-code">checkout</a>.</p>
<p>The source tree contains a build solution and project files for Microsoft
Visual Studio 2015, which is the compiler used to build the official Python
releases. These files are in the <code class="file docutils literal"><span class="pre">PCbuild</span></code> directory.</p>
<p>Check <code class="file docutils literal"><span class="pre">PCbuild/readme.txt</span></code> for general information on the build process.</p>
<p>For extension modules, consult <a class="reference internal" href="../extending/windows.html#building-on-windows"><span>Building C and C++ Extensions on Windows</span></a>.</p>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><a class="reference external" href="http://sebsauvage.net/python/mingw.html">Python + Windows + distutils + SWIG + gcc MinGW</a></dt>
<dd>or &#8220;Creating Python extensions in C/C++ with SWIG and compiling them with
MinGW gcc under Windows&#8221; or &#8220;Installing Python extension with distutils
and without Microsoft Visual C++&#8221; by Sébastien Sauvage, 2003</dd>
<dt><a class="reference external" href="http://oldwiki.mingw.org/index.php/Python%20extensions">MingW &#8211; Python extensions</a></dt>
<dd>by Trent Apted et al, 2007</dd>
</dl>
</div>
</div>
<div class="section" id="embedded-distribution">
<h2>3.8. Embedded Distribution<a class="headerlink" href="#embedded-distribution" title="Permalink to this headline">¶</a></h2>
<div class="versionadded">
<p><span class="versionmodified">New in version 3.5.</span></p>
</div>
<p>The embedded distribution is a ZIP file containing a minimal Python environment.
It is intended for acting as part of another application, rather than being
directly accessed by end-users.</p>
<p>When extracted, the embedded distribution is (almost) fully isolated from the
user&#8217;s system, including environment variables, system registry settings, and
installed packages. The standard library is included as pre-compiled and
optimized <code class="docutils literal"><span class="pre">.pyc</span></code> files in a ZIP, and <code class="docutils literal"><span class="pre">python3.dll</span></code>, <code class="docutils literal"><span class="pre">python35.dll</span></code>,
<code class="docutils literal"><span class="pre">python.exe</span></code> and <code class="docutils literal"><span class="pre">pythonw.exe</span></code> are all provided. Tcl/tk (including all
dependants, such as Idle), pip and the Python documentation are not included.</p>
<div class="admonition note">
<p class="first admonition-title">Note</p>
<p class="last">The embedded distribution does not include the <a class="reference external" href="http://www.microsoft.com/en-us/download/details.aspx?id=48145">Microsoft C Runtime</a> and it is
the responsibility of the application installer to provide this. The
runtime may have already been installed on a user&#8217;s system previously or
automatically via Windows Update, and can be detected by finding
<code class="docutils literal"><span class="pre">ucrtbase.dll</span></code> in the system directory.</p>
</div>
<p>Third-party packages should be installed by the application installer alongside
the embedded distribution. Using pip to manage dependencies as for a regular
Python installation is not supported with this distribution, though with some
care it may be possible to include and use pip for automatic updates. In
general, third-party packages should be treated as part of the application
(&#8220;vendoring&#8221;) so that the developer can ensure compatibility with newer
versions before providing updates to users.</p>
<p>The two recommended use cases for this distribution are described below.</p>
<div class="section" id="python-application">
<h3>3.8.1. Python Application<a class="headerlink" href="#python-application" title="Permalink to this headline">¶</a></h3>
<p>An application written in Python does not necessarily require users to be aware
of that fact. The embedded distribution may be used in this case to include a
private version of Python in an install package. Depending on how transparent it
should be (or conversely, how professional it should appear), there are two
options.</p>
<p>Using a specialized executable as a launcher requires some coding, but provides
the most transparent experience for users. With a customized launcher, there are
no obvious indications that the program is running on Python: icons can be
customized, company and version information can be specified, and file
associations behave properly. In most cases, a custom launcher should simply be
able to call <code class="docutils literal"><span class="pre">Py_Main</span></code> with a hard-coded command line.</p>
<p>The simpler approach is to provide a batch file or generated shortcut that
directly calls the <code class="docutils literal"><span class="pre">python.exe</span></code> or <code class="docutils literal"><span class="pre">pythonw.exe</span></code> with the required
command-line arguments. In this case, the application will appear to be Python
and not its actual name, and users may have trouble distinguishing it from other
running Python processes or file associations.</p>
<p>With the latter approach, packages should be installed as directories alongside
the Python executable to ensure they are available on the path. With the
specialized launcher, packages can be located in other locations as there is an
opportunity to specify the search path before launching the application.</p>
</div>
<div class="section" id="embedding-python">
<h3>3.8.2. Embedding Python<a class="headerlink" href="#embedding-python" title="Permalink to this headline">¶</a></h3>
<p>Applications written in native code often require some form of scripting
language, and the embedded Python distribution can be used for this purpose. In
general, the majority of the application is in native code, and some part will
either invoke <code class="docutils literal"><span class="pre">python.exe</span></code> or directly use <code class="docutils literal"><span class="pre">python3.dll</span></code>. For either case,
extracting the embedded distribution to a subdirectory of the application
installation is sufficient to provide a loadable Python interpreter.</p>
<p>As with the application use, packages can be installed to any location as there
is an opportunity to specify search paths before initializing the interpreter.
Otherwise, there is no fundamental differences between using the embedded
distribution and a regular installation.</p>
</div>
</div>
<div class="section" id="other-resources">
<h2>3.9. Other resources<a class="headerlink" href="#other-resources" title="Permalink to this headline">¶</a></h2>
<div class="admonition seealso">
<p class="first admonition-title">See also</p>
<dl class="last docutils">
<dt><a class="reference external" href="http://shop.oreilly.com/product/9781565926219.do">Python Programming On Win32</a></dt>
<dd>&#8220;Help for Windows Programmers&#8221;
by Mark Hammond and Andy Robinson, O&#8217;Reilly Media, 2000,
ISBN 1-56592-621-8</dd>
<dt><a class="reference external" href="http://www.imladris.com/Scripts/PythonForWindows.html">A Python for Windows Tutorial</a></dt>
<dd>by Amanda Birmingham, 2004</dd>
<dt><span class="target" id="index-23"></span><a class="pep reference external" href="https://www.python.org/dev/peps/pep-0397"><strong>PEP 397</strong></a> - Python launcher for Windows</dt>
<dd>The proposal for the launcher to be included in the Python distribution.</dd>
</dl>
</div>
</div>
</div>


          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../contents.html">Table Of Contents</a></h3>
  <ul>
<li><a class="reference internal" href="#">3. Using Python on Windows</a><ul>
<li><a class="reference internal" href="#installing-python">3.1. Installing Python</a><ul>
<li><a class="reference internal" href="#supported-versions">3.1.1. Supported Versions</a></li>
<li><a class="reference internal" href="#installation-steps">3.1.2. Installation Steps</a></li>
<li><a class="reference internal" href="#installing-without-ui">3.1.3. Installing Without UI</a></li>
<li><a class="reference internal" href="#installing-without-downloading">3.1.4. Installing Without Downloading</a></li>
<li><a class="reference internal" href="#modifying-an-install">3.1.5. Modifying an install</a></li>
<li><a class="reference internal" href="#other-platforms">3.1.6. Other Platforms</a></li>
</ul>
</li>
<li><a class="reference internal" href="#alternative-bundles">3.2. Alternative bundles</a></li>
<li><a class="reference internal" href="#configuring-python">3.3. Configuring Python</a><ul>
<li><a class="reference internal" href="#excursus-setting-environment-variables">3.3.1. Excursus: Setting environment variables</a></li>
<li><a class="reference internal" href="#finding-the-python-executable">3.3.2. Finding the Python executable</a></li>
</ul>
</li>
<li><a class="reference internal" href="#python-launcher-for-windows">3.4. Python Launcher for Windows</a><ul>
<li><a class="reference internal" href="#getting-started">3.4.1. Getting started</a><ul>
<li><a class="reference internal" href="#from-the-command-line">3.4.1.1. From the command-line</a></li>
<li><a class="reference internal" href="#virtual-environments">3.4.1.2. Virtual environments</a></li>
<li><a class="reference internal" href="#from-a-script">3.4.1.3. From a script</a></li>
<li><a class="reference internal" href="#from-file-associations">3.4.1.4. From file associations</a></li>
</ul>
</li>
<li><a class="reference internal" href="#shebang-lines">3.4.2. Shebang Lines</a></li>
<li><a class="reference internal" href="#arguments-in-shebang-lines">3.4.3. Arguments in shebang lines</a></li>
<li><a class="reference internal" href="#customization">3.4.4. Customization</a><ul>
<li><a class="reference internal" href="#customization-via-ini-files">3.4.4.1. Customization via INI files</a></li>
<li><a class="reference internal" href="#customizing-default-python-versions">3.4.4.2. Customizing default Python versions</a></li>
</ul>
</li>
<li><a class="reference internal" href="#diagnostics">3.4.5. Diagnostics</a></li>
</ul>
</li>
<li><a class="reference internal" href="#finding-modules">3.5. Finding modules</a></li>
<li><a class="reference internal" href="#additional-modules">3.6. Additional modules</a><ul>
<li><a class="reference internal" href="#pywin32">3.6.1. PyWin32</a></li>
<li><a class="reference internal" href="#cx-freeze">3.6.2. cx_Freeze</a></li>
<li><a class="reference internal" href="#wconio">3.6.3. WConio</a></li>
</ul>
</li>
<li><a class="reference internal" href="#compiling-python-on-windows">3.7. Compiling Python on Windows</a></li>
<li><a class="reference internal" href="#embedded-distribution">3.8. Embedded Distribution</a><ul>
<li><a class="reference internal" href="#python-application">3.8.1. Python Application</a></li>
<li><a class="reference internal" href="#embedding-python">3.8.2. Embedding Python</a></li>
</ul>
</li>
<li><a class="reference internal" href="#other-resources">3.9. Other resources</a></li>
</ul>
</li>
</ul>

  <h4>Previous topic</h4>
  <p class="topless"><a href="unix.html"
                        title="previous chapter">2. Using Python on Unix platforms</a></p>
  <h4>Next topic</h4>
  <p class="topless"><a href="mac.html"
                        title="next chapter">4. Using Python on a Macintosh</a></p>
<h3>This Page</h3>
<ul class="this-page-menu">
  <li><a href="../bugs.html">Report a Bug</a></li>
  <li><a href="../_sources/using/windows.txt"
         rel="nofollow">Show Source</a></li>
</ul>

<div id="searchbox" style="display: none" role="search">
  <h3>Quick search</h3>
    <form class="search" action="../search.html" method="get">
      <input type="text" name="q" />
      <input type="submit" value="Go" />
      <input type="hidden" name="check_keywords" value="yes" />
      <input type="hidden" name="area" value="default" />
    </form>
    <p class="searchtip" style="font-size: 90%">
    Enter search terms or a module, class or function name.
    </p>
</div>
<script type="text/javascript">$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>  
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>Navigation</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../genindex.html" title="General Index"
             >index</a></li>
        <li class="right" >
          <a href="../py-modindex.html" title="Python Module Index"
             >modules</a> |</li>
        <li class="right" >
          <a href="mac.html" title="4. Using Python on a Macintosh"
             >next</a> |</li>
        <li class="right" >
          <a href="unix.html" title="2. Using Python on Unix platforms"
             >previous</a> |</li>
        <li><img src="../_static/py.png" alt=""
                 style="vertical-align: middle; margin-top: -1px"/></li>
        <li><a href="https://www.python.org/">Python</a> &raquo;</li>
        <li>
          <span class="version_switcher_placeholder">3.5.1</span>
          <a href="../index.html">Documentation</a> &raquo;
        </li>

          <li class="nav-item nav-item-1"><a href="index.html" >Python Setup and Usage</a> &raquo;</li> 
      </ul>
    </div>  
    <div class="footer">
    &copy; <a href="../copyright.html">Copyright</a> 1990-2016, Python Software Foundation.
    <br />
    The Python Software Foundation is a non-profit corporation.
    <a href="https://www.python.org/psf/donations/">Please donate.</a>
    <br />
    Last updated on Jan 16, 2016.
    <a href="../bugs.html">Found a bug</a>?
    <br />
    Created using <a href="http://sphinx.pocoo.org/">Sphinx</a> 1.3.3.
    </div>

  </body>
</html>